/*----------------------------------------------------------------------+
|									|
|  Copyright (c) 1985-93;  Bentley Systems, Inc., All rights reserved.	|
|									|
| "MicroStation", "MDL", and "MicroCSL" are trademarks of Bentley	|
|  Systems, Inc.							|
|									|
|  Limited permission is hereby granted to reproduce and modify this	|
|  copyrighted material provided that the resulting code is used only 	|
|  in conjunction with Bentley Systems products under the terms of the	|
|  license agreement provided therein, and that this notice is retained	|
|  in its entirety in any such reproduction or modification.		|
|									|
+----------------------------------------------------------------------*/
/*----------------------------------------------------------------------+
|									|
|   msw32utl.fdf  -- Misc NT utility functions .fdf file                |
|									|
|   $Workfile:   msw32utl.fdf  $
|   $Revision:   6.0  $
|      	$Date:   Thu Oct 21 10:42:46 1993  $
|									|
+----------------------------------------------------------------------*/
#ifndef __msw32utilFDF__
#define __msw32utilFDF__

/*----------------------------------------------------------------------+
|									|
|   Header File Dependencies						|
|									|
+----------------------------------------------------------------------*/
#include <basedefs.h>
#include <w32dde.h>


/* Global Memory Flags */
#if ! defined (GMEM_FIXED)
# define GMEM_FIXED          0x0000
# define GMEM_MOVEABLE       0x0002
# define GMEM_NOCOMPACT      0x0010
# define GMEM_NODISCARD      0x0020
# define GMEM_ZEROINIT       0x0040
# define GMEM_MODIFY         0x0080
# define GMEM_DISCARDABLE    0x0100
# define GMEM_NOT_BANKED     0x1000
# define GMEM_SHARE          0x2000
# define GMEM_DDESHARE       0x2000
# define GMEM_NOTIFY         0x4000
# define GMEM_LOWER          GMEM_NOT_BANKED
# define GMEM_VALID_FLAGS    0x7F72
# define GMEM_INVALID_HANDLE 0x8000

# define GHND                (GMEM_MOVEABLE | GMEM_ZEROINIT)
# define GPTR                (GMEM_FIXED | GMEM_ZEROINIT)

/* Flags returned by GlobalFlags (in addition to GMEM_DISCARDABLE) */
# define GMEM_DISCARDED      0x4000
# define GMEM_LOCKCOUNT      0x00FF
#endif



/*======================================================================+
|									|
|   Major Public Code Section						|
|									|
+======================================================================*/

DWORD	mdlWin32_GetLastError
(
void
);

void	mdlWin32_SetLastError
(
DWORD		errno
);

int	mdlWin32_readDataFromHandle
(
HANDLE		hMem,
void	      **mdlMemPP,
UInt	       *mdlMemLen
);

HANDLE mdlWin32_createDataHandle
(
UINT		flags,
void	       *mdlMemP,
UInt		mdlMemLen
);

HANDLE mdlWin32_destroyDataHandle
(
HANDLE		hMem
);

HANDLE mdlWin32_writeDataToHandle
(
HANDLE		hMem,
void	       *mdlMemP,
UInt		mdlMemLen
);

#endif
